module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 17);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("classnames");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("react-fela");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("@xterm-stack/client-redux");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("@xterm-stack/graphql");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("react-redux");

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const xterm_header_1 = __webpack_require__(15);
exports.XtermHeaderComponent = xterm_header_1.default;
const xterm_1 = __webpack_require__(16);
exports.XtermComponent = xterm_1.default;


/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = require("ramda");

/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = require("react-apollo");

/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("reselect");

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(1);
const cx = __webpack_require__(0);
const react_redux_1 = __webpack_require__(5);
const redux_1 = __webpack_require__(18);
const react_fela_1 = __webpack_require__(2);
const mapStateToProps = (state, props) => ({
    color: state.terminalColor,
    theme: state.terminalTheme,
});
exports.default = redux_1.compose(...[
    react_redux_1.connect(mapStateToProps),
    react_fela_1.connect({
        container: () => ({
            height: '100%',
        }),
        terminal: () => ({}),
    }),
])(({ styles, className, theme, children }) => (React.createElement("div", { className: cx(className, styles.container, (theme && theme.className)) }, children)));


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(1);
const cx = __webpack_require__(0);
const react_fela_1 = __webpack_require__(2);
exports.default = react_fela_1.connect({
    container: () => ({
        height: '100%',
        display: 'flex',
        fontSize: '13px',
        lineHeight: 1.4,
        position: 'relative',
        zIndex: 1,
        overflow: 'hidden',
    }),
})(({ styles, children }) => (React.createElement("div", { className: cx('monaco-workbench', styles.container) }, children)));


/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const reselect_1 = __webpack_require__(9);
const react_redux_1 = __webpack_require__(5);
const react_fela_1 = __webpack_require__(2);
const client_redux_1 = __webpack_require__(3);
const react_apollo_1 = __webpack_require__(8);
const graphql_1 = __webpack_require__(4);
const components_1 = __webpack_require__(6);
const XtermHeaderWithData = react_apollo_1.compose(react_apollo_1.graphql(graphql_1.DELETE_INSTANCE_MUTATION, {
    props: ({ mutate }) => ({
        deleteInstance: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_1.TERMINAL_INSTANCES_QUERY, {
    props: reselect_1.createSelector(({ data: { loading, error, terminalInstances, refetch } }) => ({ loading, error, terminalInstances, refetch }), ({ loading, error, terminalInstances, refetch }) => ({
        loading,
        error,
        terminalInstances,
        refetchTerminalInstances: refetch,
    })),
}), react_apollo_1.graphql(graphql_1.GET_ACTIVE_INSTANCE_QUERY, {
    props: reselect_1.createSelector(({ data: { getActiveInstance, subscribeToMore, refetch } }) => ({ getActiveInstance, subscribeToMore, refetch }), ({ getActiveInstance, subscribeToMore, refetch }) => ({
        activeInstance: getActiveInstance,
        refetchActiveInstance: refetch,
    })),
}))(components_1.XtermHeaderComponent);
const mapStateToProps = (state, props) => ({
    color: state.terminalColor,
    theme: state.terminalTheme,
});
const mapDispatchToProps = (dispatch) => ({
    removeInstanceBuffer: (id) => {
        dispatch(client_redux_1.removeInstanceBuffer(id));
    },
    loadColor: () => {
        dispatch(client_redux_1.loadColor());
    },
    setColor: (color) => {
        dispatch(client_redux_1.setColor(color));
    },
    loadTheme: () => {
        dispatch(client_redux_1.loadTheme());
    },
    setTheme: (theme) => {
        dispatch(client_redux_1.setTheme(theme));
    },
    createInstance: () => {
        dispatch(client_redux_1.createInstance());
    },
    activateInstance: (instance) => {
        dispatch(client_redux_1.activateInstance(instance));
    },
});
exports.default = react_apollo_1.compose(...[
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
    react_fela_1.connect({
        container: () => ({
            display: 'flex',
            'justify-content': 'space-between',
            padding: '6px 20px',
            fontSize: '11px',
            '> div': {
                display: 'flex',
                'justify-content': 'flex-end',
            },
        }),
        actions: () => ({
            display: 'flex',
            'justify-content': 'space-around',
        }),
        action: () => ({
            display: 'inline-block',
            cursor: 'pointer',
            width: '32px',
            height: '20px',
            padding: '0 10px',
        }),
        select: () => ({
            '> select': {
                marginRight: '20px',
                height: '22px',
            }
        }),
    }),
])(XtermHeaderWithData);


/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const reselect_1 = __webpack_require__(9);
const react_redux_1 = __webpack_require__(5);
const react_fela_1 = __webpack_require__(2);
const client_redux_1 = __webpack_require__(3);
const react_apollo_1 = __webpack_require__(8);
const graphql_1 = __webpack_require__(4);
const components_1 = __webpack_require__(6);
const XtermWithData = react_apollo_1.compose(react_apollo_1.graphql(graphql_1.CREATE_INSTANCE_MUTATION, {
    props: ({ mutate }) => ({
        createInstance: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_1.SEND_TEXT_MUTATION, {
    props: ({ mutate }) => ({
        sendText: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_1.SET_ACTIVE_INSTANCE_MUTATION, {
    props: ({ mutate }) => ({
        setActiveInstance: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_1.SET_INSTANCE_SIZE_MUTATION, {
    props: ({ mutate }) => ({
        setInstanceSize: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_1.TERMINAL_INSTANCES_QUERY, {
    props: reselect_1.createSelector(({ data: { loading, error, terminalInstances, refetch } }) => ({ loading, error, terminalInstances, refetch }), ({ loading, error, terminalInstances, refetch }) => ({
        loading,
        error,
        terminalInstances,
        refetchTerminalInstances: refetch,
    })),
}), react_apollo_1.graphql(graphql_1.GET_ACTIVE_INSTANCE_QUERY, {
    props: reselect_1.createSelector(({ data: { getActiveInstance, subscribeToMore, refetch } }) => ({ getActiveInstance, subscribeToMore, refetch }), ({ getActiveInstance, subscribeToMore, refetch }) => ({
        activeInstance: getActiveInstance,
        getTerminalData: subscribeToMore,
        refetchActiveInstance: refetch,
    })),
}))(components_1.XtermComponent);
const mapStateToProps = (state, props) => ({
    color: state.terminalColor,
    buffers: state.buffers,
    terminalTheme: state.terminalTheme,
    terminalAction: state.terminalAction,
    height: state.resize.consolePanel,
    left: state.resize.treePanel,
});
const mapDispatchToProps = (dispatch) => ({
    saveInstanceBuffer: (id, buffer) => {
        dispatch(client_redux_1.saveInstanceBuffer(id, buffer));
    },
    resetCommand: () => {
        dispatch(client_redux_1.resetCommand());
    },
});
exports.default = react_apollo_1.compose(...[
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
    react_fela_1.connect({
        container: () => ({
            'align-content': 'flex-start',
            'align-items': 'baseline',
            color: '#333',
            display: 'flex',
            'flex-direction': 'column',
            'font-variant-ligatures': 'none',
            height: 'calc(100% - 0px)',
            width: '100%',
            padding: '0 20px',
            position: 'relative',
        }),
        color: ({ terminalTheme, color }) => {
            let themeName = terminalTheme ? terminalTheme.name : null;
            let terminalColor = color && themeName ? color[themeName] : '';
            return ({
                '> .terminal-container .terminal': {
                    color: `${terminalColor} !important`,
                }
            });
        },
        finder: () => ({
            position: 'absolute',
            display: 'flex',
            top: 0,
            right: '2px',
            height: '30px',
            overflow: 'hidden',
            lineHeight: '19px',
            padding: '4px',
            zIndex: 10,
            transition: 'top 200ms linear',
            boxShadow: '0px 1px 8px rgba(0,0,0,0.8)',
            '>input': {
                fontSize: '13px',
                backgroundColor: 'transparent',
                outline: 'none',
                width: '120px',
            },
            '>span': {
                width: '20px',
                height: '20px',
                display: 'inline-block',
                verticalAlign: 'middle',
                marginLeft: '3px',
                cursor: 'pointer',
            }
        })
    }),
])(XtermWithData);


/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(1);
const cx = __webpack_require__(0);
const __ENTER_KEY_CODE__ = 13;
class XtermFinder extends React.Component {
    constructor(props, context) {
        super(props, context);
        this.state = {
            text: '',
        };
    }
    handleText(e) {
        this.setState({ text: e.target.value });
    }
    handleFindNext(e) {
        this.props.onFindNext(this.state.text);
    }
    handleFindPrev(e) {
        this.props.onFindPrevious(this.state.text);
    }
    handleKeyDown(e) {
        if (e.keyCode === __ENTER_KEY_CODE__) {
            e.preventDefault();
            this.handleFindNext(e);
        }
    }
    handleClose(e) {
        this.props.onClose();
    }
    render() {
        const { className } = this.props;
        return (React.createElement("div", { className: cx('find-widget', className) },
            React.createElement("input", { type: "text", onKeyDown: (e) => this.handleKeyDown(e), onChange: (e) => this.handleText(e) }),
            React.createElement("span", { className: 'previous', onClick: (e) => this.handleFindPrev(e) }),
            React.createElement("span", { className: 'next', onClick: (e) => this.handleFindNext(e) }),
            React.createElement("span", { className: 'closer', onClick: (e) => this.handleClose(e) })));
    }
}
exports.default = XtermFinder;


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const R = __webpack_require__(7);
const React = __webpack_require__(1);
const cx = __webpack_require__(0);
const client_redux_1 = __webpack_require__(3);
class XtermHeaderComponent extends React.Component {
    componentDidMount() {
        this.props.loadColor();
        this.props.loadTheme();
    }
    componentWillReceiveProps(nextProps) {
        const { loading, activeInstance } = nextProps;
        if (!loading && activeInstance && this.currentInstance) {
            this.currentInstance.value = activeInstance.id;
        }
    }
    deleteInstance() {
        const { terminalInstances, activeInstance } = this.props;
        if (terminalInstances.length > 1 && activeInstance) {
            this.props.removeInstanceBuffer(activeInstance.id);
            this.props.deleteInstance({ id: activeInstance.id })
                .then(({ data: { deleteInstance: result } }) => {
                console.log('instance deleted', activeInstance.id, result);
                this.props.refetchTerminalInstances();
                this.props.refetchActiveInstance();
            })
                .catch((error) => {
                console.log(error);
            });
        }
        else {
            console.error('You must have at least 2 instances to delete.');
        }
    }
    handleAction(action) {
        if (action == 'new') {
            this.props.createInstance();
        }
        else if (action == 'kill') {
            this.deleteInstance();
        }
    }
    handleActiveInstance(e) {
        const { terminalInstances, activeInstance } = this.props;
        const selectedInstance = R.find(R.propEq('id', parseInt(this.currentInstance.value)))(terminalInstances);
        if (selectedInstance !== undefined) {
            this.props.activateInstance(selectedInstance);
        }
    }
    handleColor(e) {
        const selectedColor = R.find(R.propEq('name', e.target.value))(client_redux_1.colors);
        this.props.setColor(selectedColor);
    }
    handleTheme(e) {
        const selectedTheme = R.find(R.propEq('name', e.target.value))(client_redux_1.themes);
        this.props.setTheme(selectedTheme);
    }
    render() {
        const { terminalInstances, activeInstance, color, theme, styles } = this.props;
        let colorName = color ? color.name : '';
        let themeName = theme ? theme.name : '';
        return (React.createElement("div", { className: styles.container },
            React.createElement("div", { className: cx("themes", styles.select) },
                React.createElement("select", { value: themeName, onChange: (e) => this.handleTheme(e) }, client_redux_1.themes && client_redux_1.themes.map((theme, i) => (React.createElement("option", { key: i, value: theme.name }, theme.text))))),
            React.createElement("div", { className: cx("colors", styles.select) },
                React.createElement("select", { value: colorName, onChange: (e) => this.handleColor(e) }, client_redux_1.colors && client_redux_1.colors.map((color, i) => (React.createElement("option", { key: i, value: color.name }, color.name))))),
            React.createElement("div", { className: cx("instances", styles.select) },
                React.createElement("select", { ref: (r) => this.currentInstance = r, onChange: (e) => this.handleActiveInstance(e) }, terminalInstances && terminalInstances.map((instance, i) => (React.createElement("option", { key: i, value: instance.id }, `${i + 1}: ${instance.title}`))))),
            React.createElement("div", { className: cx("actions", styles.actions) },
                React.createElement("div", { className: cx("terminal-action", "new", styles.action), onClick: (e) => this.handleAction('new') }),
                React.createElement("div", { className: cx("terminal-action", "kill", styles.action), onClick: (e) => this.handleAction('kill') }))));
    }
}
exports.default = XtermHeaderComponent;


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const R = __webpack_require__(7);
const React = __webpack_require__(1);
const Xterm = __webpack_require__(19);
const cx = __webpack_require__(0);
const graphql_1 = __webpack_require__(4);
const xterm_finder_1 = __webpack_require__(14);
Xterm.loadAddon('search');
Xterm.loadAddon('fit');
const __ENTER_KEY_CODE__ = 13;
const __BACKSPACE_KEY_CODE__ = 8;
class XtermComponent extends React.Component {
    constructor(props, context) {
        super(props, context);
        this.buffer = '';
        this.fit = () => {
            return new Promise((resolve) => {
                window.setTimeout(() => {
                    let geometry = this.xterm.proposeGeometry();
                    if (geometry) {
                        this.xterm.resize(geometry.cols, geometry.rows);
                    }
                    resolve();
                }, 100);
            });
        };
        this.state = {
            isFocused: false,
            creating: false,
            finding: false,
        };
    }
    componentDidMount() {
        const xtermInstance = this.getXtermInstance();
        const options = {
            cursorBlink: false,
        };
        this.xterm = new xtermInstance(options);
        this.xterm.on('focus', this.focusChanged.bind(this, true));
        this.xterm.on('blur', this.focusChanged.bind(this, false));
        this.xterm.on('data', this.onData.bind(this));
        this.xterm.on('resize', this.onResize.bind(this));
        this.xterm.open(this.refs.container, true);
        window.onresize = this.fit;
        this.fit().then(() => {
            if (this.props.activeInstance) {
                this.writeBuffer(this.props.activeInstance);
            }
        });
    }
    componentWillUnmount() {
        if (this.props.activeInstance) {
            this.props.saveInstanceBuffer(this.props.activeInstance.id, this.buffer);
        }
        if (this.xterm) {
            this.xterm.destroy();
            this.xterm = null;
        }
    }
    componentWillReceiveProps(nextProps) {
        const { loading, terminalInstances, activeInstance, buffers, terminalAction, height, left } = nextProps;
        const { loading: prevLoading, activeInstance: prevActiveInstance, terminalAction: prevTerminalAction } = this.props;
        if (prevLoading && !loading && terminalInstances && !terminalInstances.length) {
            if (!this.state.creating) {
                this.setState({ creating: true });
                this.createInstance();
            }
        }
        else if (!loading && !this.unsubscribe && activeInstance) {
            this.getTerminalData(activeInstance);
        }
        else if (terminalAction && !prevTerminalAction) {
            this.processAction(terminalAction);
        }
        if (prevActiveInstance && activeInstance && prevActiveInstance.id !== activeInstance.id) {
            this.writeBuffer(activeInstance);
        }
        if (height != this.props.height || left != this.props.left) {
            this.fit();
        }
    }
    getXtermInstance() {
        if (!this.xtermInstance) {
            this.xtermInstance = Xterm;
        }
        return this.xtermInstance;
    }
    processAction(terminalAction) {
        if (terminalAction.command == 'create-instance') {
            this.createInstance().then(() => {
                this.props.resetCommand();
            });
        }
        else if (terminalAction.command == 'activate-instance') {
            this.setActiveInstance(terminalAction.instance).then(() => {
                this.props.resetCommand();
            });
        }
    }
    getTerminalData(activeInstance) {
        this.unsubscribe = this.props.getTerminalData({
            document: graphql_1.TERMINAL_DATA_SUBSCRIPTION,
            variables: { id: activeInstance.id },
            updateQuery: ({ getActiveInstance: prevActiveInstance }, { subscriptionData }) => {
                const terminalData = subscriptionData.data.terminalData;
                if (activeInstance.id === terminalData.id) {
                    let message = terminalData.msg;
                    if (this.xterm)
                        this.xterm.write(message);
                    this.buffer += message;
                }
            },
            onError: (err) => {
                console.error(err);
            },
        });
    }
    createInstance() {
        const { terminalInstances } = this.props;
        let config = {};
        let count = terminalInstances && terminalInstances.length || 0;
        const shellConfig = {
            name: `instance${count + 1}`,
        };
        let geometry = this.xterm.proposeGeometry();
        if (geometry) {
            const dimension = {
                width: geometry.cols,
                height: geometry.rows,
            };
            config = {
                shell: shellConfig,
                dimension,
            };
        }
        else {
            config = {
                shell: shellConfig,
            };
        }
        return this.props.createInstance(config)
            .then(({ data: { createInstance: newInstance } }) => {
            console.log('new instance created', newInstance);
            this.setState({ creating: false });
            this.props.refetchTerminalInstances();
            this.setActiveInstance(newInstance);
        })
            .catch((error) => {
            console.log(error);
            this.setState({ creating: false });
        });
    }
    setActiveInstance(instance) {
        const { activeInstance } = this.props;
        if (activeInstance) {
            this.props.saveInstanceBuffer(activeInstance.id, this.buffer);
        }
        return this.props.setActiveInstance({ terminalInstance: { id: instance.id, processId: instance.processId } })
            .then(({ data: { setActiveInstance: newActiveInstance } }) => {
            console.log('active instance changed', newActiveInstance);
            this.props.refetchActiveInstance();
            if (this.unsubscribe) {
                this.unsubscribe();
            }
            this.getTerminalData(newActiveInstance);
            this.xterm.showCursor();
        })
            .catch((error) => {
            console.log(error);
        });
    }
    onResize({ cols, rows }) {
        if (this.props.activeInstance) {
            this.props.setInstanceSize({ id: this.props.activeInstance.id, dimension: { width: cols, height: rows } })
                .then((data) => { })
                .catch((error) => {
                console.log(error);
            });
        }
    }
    async onData(text) {
        if (!this.props.activeInstance) {
            return;
        }
        try {
            await this.props.sendText({ id: this.props.activeInstance.id, text, addNewLine: false });
        }
        catch (e) {
        }
    }
    onInput(key, ev) {
        const printable = !ev.altKey && !ev.altGraphKey && !ev.ctrlKey && !ev.metaKey;
        if (ev.keyCode === __ENTER_KEY_CODE__) {
            if (this.props.terminalInstances && this.props.terminalInstances.length) {
                this.xterm.writeln('');
                this.props.sendText({ id: this.props.activeInstance.id, text: key, addNewLine: false })
                    .then((data) => {
                })
                    .catch((error) => {
                    console.log(error);
                });
            }
        }
        else if (ev.keyCode === __BACKSPACE_KEY_CODE__) {
        }
        else if (printable) {
            this.xterm.write(key);
        }
    }
    onKeyDown(event) {
        let charCode = String.fromCharCode(event.which).toLowerCase();
        if (event.ctrlKey && charCode === 'f' || event.metaKey && charCode === 'f') {
            event.preventDefault();
            this.setState({ finding: true });
        }
    }
    writeBuffer(activeInstance) {
        const { buffers } = this.props;
        let buffer = '';
        if (activeInstance) {
            const index = R.findIndex(R.propEq('id', activeInstance.id))(buffers);
            if (index !== -1) {
                buffer = buffers[index].buffer;
            }
        }
        this.buffer = buffer;
        this.xterm.reset();
        if (buffer != '') {
            this.xterm.write(buffer);
        }
        this.xterm.showCursor();
    }
    focusChanged(focused) {
        this.setState({
            isFocused: focused,
        });
        this.props.onFocusChange && this.props.onFocusChange(focused);
    }
    render() {
        let { value, color, terminalTheme, styles } = this.props;
        const terminalClassName = cx('terminal-container', this.state.isFocused ? 'terminal-container--focused' : null);
        if (value) {
            this.xterm.write(value);
        }
        return (React.createElement("div", { className: cx('react-terminal', styles.container, styles.color), onKeyDown: (e) => this.onKeyDown(e) },
            this.state.finding ?
                React.createElement(xterm_finder_1.default, { className: styles.finder, onFindNext: (text) => this.xterm.findNext(text), onFindPrevious: (text) => this.xterm.findPrevious(text), onClose: () => this.setState({ finding: false }) })
                : null,
            React.createElement("div", { ref: "container", className: terminalClassName })));
    }
}
exports.default = XtermComponent;


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var xterm_1 = __webpack_require__(13);
exports.Xterm = xterm_1.default;
var xterm_header_1 = __webpack_require__(12);
exports.XtermHeader = xterm_header_1.default;
var workbench_1 = __webpack_require__(11);
exports.Workbench = workbench_1.default;
var theme_1 = __webpack_require__(10);
exports.Theme = theme_1.default;


/***/ }),
/* 18 */
/***/ (function(module, exports) {

module.exports = require("redux");

/***/ }),
/* 19 */
/***/ (function(module, exports) {

module.exports = require("xterm");

/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map